import { PRE_GAME, PRE_ROUND, IN_ROUND, POST_ROUND, POST_GAME } from "./GameState";
import { createStore } from "../store";
import { createGame, joinGame } from "./GGSHService";

export const [
  {
    useGameId,
    usePlayerName,
    useLastRound,
    useGameJoined,
    useGameState,
  },
  dispatch,
] = createStore({
  gameId: null,
  playerName: null,
  lastRound: null,
  gameJoined: false,
  gameState: PRE_GAME,
}, {
  setGameId: ([set], gameId) => set({ gameId }),
  getGameId: ([_, get]) => get.gameId(),
  setPlayerName: ([set], playerName) => set({ playerName }),
  getPlayerName: ([_, get]) => get.playerName(),
  resetGame: ([set]) => set({ gameJoined: false, gameState: PRE_GAME }),
  startGame: ([set]) => set({ gameState: PRE_ROUND }),
  startRound: ([set]) => set({ gameState: IN_ROUND }),
  endRound: ([set], lastRound) => set({ lastRound, gameState: POST_ROUND }),
  endGame: ([set]) => set({ gameState: POST_GAME }),
  createGameAndStart: async ([set, get], timer) => {
    const name = get.playerName();
    const gameId = await createGame(name, timer);
    set({ gameId, gameJoined: true, gameState: PRE_ROUND });
  },
  joinGame: async ([set, get]) => {
    const gameId = get.gameId();
    const name = get.playerName();
    await joinGame(gameId, name);
    set({ gameJoined: true });
  },
});